<!--
  - Pfarrplaner
  -
  - @package Pfarrplaner
  - @author Christoph Fischer <chris@toph.de>
  - @copyright (c) Christoph Fischer, https://christoph-fischer.org
  - @license https://www.gnu.org/licenses/gpl-3.0.txt GPL 3.0 or later
  - @link https://codeberg.org/pfarr.tools/pfarrplaner
  - @version git: $Id$
  -
  - Sponsored by: Evangelischer Kirchenbezirk Balingen, https://www.kirchenbezirk-balingen.de
  -
  - Pfarrplaner is based on the Laravel framework (https://laravel.com).
  - This file may contain code created by Laravel's scaffolding functions.
  -
  - This program is free software: you can redistribute it and/or modify
  - it under the terms of the GNU General Public License as published by
  - the Free Software Foundation, either version 3 of the License, or
  - (at your option) any later version.
  -
  - This program is distributed in the hope that it will be useful,
  - but WITHOUT ANY WARRANTY; without even the implied warranty of
  - MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  - GNU General Public License for more details.
  -
  - You should have received a copy of the GNU General Public License
  - along with this program.  If not, see <http://www.gnu.org/licenses/>.
  -->

<template>
    <div class="container pt-3">
        <div class="alert alert-info" v-if="services.length == 0">
        Heute gibt es keine Gottesdienste mit QR-Codes in {{ city.name }}.
        </div>
        <accordion v-else id="servicesAccordion">
            <accordion-element v-for="(service,serviceIndex,serviceKey) in services"
                               v-if="service.konfiapp_event_qr"
                               :title="service.timeText+': '+service.titleText+' ('+service.locationText+')'"
                               :key="serviceKey">
                <img :src="route('qrcode', service.konfiapp_event_qr)" class="img-fluid qr" />
                <div class="text-small">{{getType(service)}}</div>
            </accordion-element>
        </accordion>
        <div v-if="servicesWithoutQR">
            <hr />
            <h3>Gottesdienste ohne QR-Code</h3>
            <p>Vielleicht ist für den gesuchten Gottesdienst noch kein QR-Code angelegt?</p>

            <table class="table table-striped">
                <thead></thead>
                <tbody>
                    <tr v-for="(service,serviceIndex,serviceKey) in myServicesWithoutQR"
                        :title="service.timeText+': '+service.titleText+' ('+service.locationText+')'"
                        :key="serviceKey">
                        <td>{{ service.timeText + ': ' + service.titleText + ' (' + service.locationText + ')' }}</td>
                        <td class="text-end">
                            <form-selectize :options="types" v-model="service.konfiapp_event_type" class="text-start"/>
                            <button class="btn btn-sm btn-secondary" @click="createQR(service)"><span class="mdi mdi-qrcode"></span> Anlegen</button>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
    </div>
</template>

<script>
import Accordion from "../../../components/Ui/accordion/Accordion";
import AccordionElement from "../../../components/Ui/accordion/AccordionElement";
import FormSelectize from "../../../components/Ui/forms/FormSelectize.vue";

export default {
    name: "QR",
    components: {FormSelectize, AccordionElement, Accordion},
    props: ['services', 'city', 'types', 'servicesWithoutQR'],
    data() {
        let myServicesWithoutQR = this.servicesWithoutQR;
        for (let index in myServicesWithoutQR) {
            myServicesWithoutQR[index].konfiapp_event_type = this.city.konfiapp_default_type || null;
        }

        return {
            myServicesWithoutQR,
        }
    },
    methods: {
        getType(service) {
            let filtered = this.types.filter(item => {
                return item.id == service.konfiapp_event_type;
            });
            if (filtered.length == 0) return '';
            return filtered[0]['punktzahl']+(filtered[0]['punktzahl'] == 1 ? ' Punkt' : ' Punkte')+' in der Kategorie '+filtered[0]['name'];
        },
        createQR(service) {
            if (!service.konfiapp_event_type) return;
            this.$inertia.post(route('service.createQR', service.slug), {
                type: service.konfiapp_event_type,
            });
        }
    }
}
</script>

<style scoped>
    .qr {
        width: 100%;
    }
</style>
